SystemOrganization addCategory: #'Pier-Book'!

!PRStructure methodsFor: '*pier-book' stamp: 'lr 4/24/2009 11:56'!
isPublication
	^ false! !

PRLink subclass: #BOIndexLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:08'!
isAbstract
	^ false! !

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:09'!
isValidReference: aString
	^ aString beginsWith: 'index:'! !

!BOIndexLink methodsFor: 'visiting' stamp: 'lr 5/1/2009 22:09'!
accept: aVisitor
	aVisitor visitIndexLink: self! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/1/2009 22:13'!
title
	^ super title copyAfter: $:! !

!PRLinkRenderer methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:35'!
visitIndexLink: aLink
	html anchor name: aLink title.
	parent visitAll: aLink children! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:11'!
visitIndexLink: aLink
	self visitLink: aLink! !

PRCase subclass: #BOBook
	instanceVariableNames: 'subtitle tagline authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:35'!
canBeChildOf: aStructureClass
	^ ((aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPublication ]) not! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:38'!
descriptionAuthors
	^ MAStringDescription new
		parameterName: 'authors';
		accessor: #authors;
		label: 'Authors';
		beSearchable;
		priority: 400;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 11:54'!
descriptionNumber
	^ nil! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionSubtitle
	^ MAStringDescription new
		parameterName: 'subtitle';
		accessor: #subtitle;
		label: 'Subtitle';
		beSearchable;
		priority: 200;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionTagline
	^ MAStringDescription new
		parameterName: 'tagline';
		accessor: #tagline;
		label: 'Tagline';
		beSearchable;
		priority: 300;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 12:33'!
isAbstract
	^ false! !

!BOBook class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:31'!
label
	^ 'Book'! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors
	^ authors! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors: anObject
	authors := anObject! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:25'!
isBook
	^ true! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isChapter
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isPart
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isPublication
	^ true! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isSection
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isSubsection
	^ false! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle
	^ subtitle! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle: aString
	subtitle := aString! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline
	^ tagline! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline: aString
	tagline := aString! !

PRCase subclass: #BOPublication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

BOPublication subclass: #BOChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOChapter class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:36'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPart ]! !

!BOChapter class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Chapter'! !

!BOChapter methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:29'!
index
	"Answer the chapter of this publication. Chapters can be on different levels, thus we need different numbering."
	
	| root siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	root := self parent 
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	siblings := root enumerator everything
		select: [ :each | each isPublication and: [ each isChapter ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOChapter methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isChapter
	^ true! !

BOPublication subclass: #BOPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOPart class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:15'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOBook! !

!BOPart class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:37'!
label
	^ 'Book Part'! !

!BOPart methodsFor: 'private' stamp: 'lr 5/2/2009 15:56'!
arabicToRoman: anInteger
	"Convert an arabic integer to a roman string."
	
	| number roman |
	number := anInteger.
	roman := WriteStream on: String new.
	#((1000 'M') (900 'CM') (500 'D') (400 'CD') (100 'C') (90 'XC') (50 'L') (40 'XL') (10 'X') (9 'IX') (5 'V') (4 'IV') (1 'I')) do: [ :pair |
		[ number >= pair first ] whileTrue: [
			roman nextPutAll: pair second.
			number := number - pair first ] ].
	^ roman contents! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:28'!
index
	^ nil! !

!BOPart methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ true! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:56'!
number
	^ self arabicToRoman: super index! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 12:20'!
descriptionNumber
	^ MAStringDescription new
		parameterName: 'number';
		accessor: #number;
		beReadonly;
		yourself! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:21'!
isAbstract
	^ self name = #POPublication! !

!BOPublication methodsFor: 'comparing' stamp: 'lr 4/24/2009 12:10'!
< aStructure
	| siblings |
	(self parent isNil or: [ self parent ~= aStructure parent ])
		ifTrue: [ ^ super < aStructure ].
	(aStructure isPublication)
		ifFalse: [ ^ false ].
	siblings := self parent childrenDecoration children.
	^ (siblings indexOf: self) < (siblings indexOf: aStructure)
		! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:29'!
index
	"Answer the index number of this publication, for example the chapter or section number."
	
	| siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	siblings := self parent childrenDecoration children
		select: [ :each | each isPublication and: [ each class = self class ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isBook
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:40'!
isChapter
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/23/2009 19:32'!
isPublication
	^ true! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ false! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:33'!
number
	"Answer the composed numbers."

	| book publications |
	book := self 
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	publications := (self parents
		select: [ :each | each isPublication ])
		copyAfter: book.
	^ (((publications	
		collect: [ :each | each index ])
		reject: [ :each | each isNil ])
		collect: [ :each | each asString ])
		reduce: [ :a :b | a , '.' , b ]! !

BOPublication subclass: #BOSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOSection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOChapter! !

!BOSection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Section'! !

!BOSection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ true! !

BOPublication subclass: #BOSubsection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOSubsection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:33'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOSection! !

!BOSubsection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Subsection'! !

!BOSubsection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ true! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 09:23'!
bookIndexIn: aContext
	<value: 'book.index' comment: 'Display an index of keywords.'>

	^ self lookupStructure: aContext structure do: [ :root |
		| index |
		index := Dictionary new.
		root enumerator everything do: [ :struct |
			struct outgoingReferences do: [ :refer |
				(refer isKindOf: BOIndexLink) ifTrue: [ 
					(index at: refer title ifAbsentPut: [ OrderedCollection new ])
						addLast: refer owner ] ] ].
		(index keys asSortedCollection: [ :a :b | a asLowercase < b asLowercase ])
			inject: PRDefinitionList new
			into: [ :list :word |
				list add: (PRTermItem with: (PRText content: word)).
				(index at: word) do: [ :struct |
					list add: (PRDataItem with: (PRInternalLink new
						anchor: word;
						target: struct;
						yourself)) ].
				list ] ]! !

!PRValueLink methodsFor: '*pier-book-private' stamp: 'lr 5/2/2009 09:59'!
bookLabel: aString target: aStructure to: aDefinitionList
	^ aDefinitionList
		add: (PRTermItem with: (PRText content: (aStructure isNil
			ifTrue: [ '&nbsp;' ]
			ifFalse: [ aString ])));
		add: (PRDataItem with: (aStructure isNil
			ifTrue: [ PRText content: '&nbsp;' ]
			ifFalse: [ PRInternalLink new target: aStructure ]));
		yourself! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 09:56'!
bookNavigationIn: aContext
	<value: 'book.navigation' comment: 'Display a navigation structure for books.'>

	| structures index result |
	^ self lookupStructure: aContext structure do: [ :structure |
		structures := (aContext enumeratorFor: aContext root) everything
			select: [ :each | each isPublication ].
		index := structures indexOf: (structure 
			findAncestor: [ :each | each isPublication ]).
		result := PRDefinitionList new.
		self 
			bookLabel: '&rarr;' target: (structures at: index + 1 ifAbsent: [ nil ]) to: result;
			bookLabel: '&larr;' target: (structures at: index - 1 ifAbsent: [ nil ]) to: result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 10:06'!
bookParentIn: aContext
	<value: 'book.parent' comment: 'Display the parent structure for books.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			bookLabel: '&sect;' 
			target: (structure isRoot
				ifFalse: [ structure parent findAncestor: [ :each | each isPublication ] ]) 
			to: PRDefinitionList new ]! !
